'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _urlSearchParams = require('url-search-params');

var _urlSearchParams2 = _interopRequireDefault(_urlSearchParams);

var _PdfHighlighter = require('./PdfHighlighter');

var _PdfHighlighter2 = _interopRequireDefault(_PdfHighlighter);

var _Highlight = require('./Highlight');

var _Highlight2 = _interopRequireDefault(_Highlight);

var _Popup = require('./Popup');

var _Popup2 = _interopRequireDefault(_Popup);

var _PdfLoader = require('./PdfLoader');

var _PdfLoader2 = _interopRequireDefault(_PdfLoader);

var _pdfWorker = require('pdfjs-dist/build/pdf.worker.entry');

var _pdfWorker2 = _interopRequireDefault(_pdfWorker);

var _pdfjsDist = require('pdfjs-dist');

var _pdfjsDist2 = _interopRequireDefault(_pdfjsDist);

var _Spinner = require('./Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

_pdfjsDist2.default.GlobalWorkerOptions.workerSrc = _pdfWorker2.default;

var location = Location;
var getNextId = function getNextId() {
  return String(Math.random()).slice(2);
};

var resetHash = function resetHash() {
  location.hash = "";
};

var HighlightPopup = function HighlightPopup(_ref) {
  var comment = _ref.comment;
  return comment.text ? _react2.default.createElement(
    'div',
    { className: 'Highlight__popup' },
    comment.emoji,
    ' ',
    comment.text
  ) : null;
};

var CustomHighlighter = function (_Component) {
  _inherits(CustomHighlighter, _Component);

  function CustomHighlighter() {
    var _temp, _this, _ret;

    _classCallCheck(this, CustomHighlighter);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      highlights: []
    }, _this.resetHighlights = function () {
      _this.setState({
        highlights: []
      });
    }, _this.scrollViewerTo = function (highlight) {
      console.log(highlight);
    }, _this.scrollToHighlightFromHash = function (obj) {
      if (Array.isArray(obj)) {
        obj.map(function (item) {
          _this.scrollViewerTo(item);
        });
      } else if (obj) {
        try {
          _this.scrollViewerTo(obj);
        } catch (e) {
          console.log(e); //'viewport' of undefined
        }
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  CustomHighlighter.prototype.componentDidMount = function componentDidMount() {};

  CustomHighlighter.prototype.getHighlightById = function getHighlightById(id) {
    var highlights = this.state.highlights;

    return highlights.find(function (highlight) {
      return highlight.id === id;
    });
  };

  CustomHighlighter.prototype.addHighlight = function addHighlight(highlight) {
    var highlights = this.state.highlights;


    console.log("Saving highlight", highlight);

    this.setState({
      highlights: [_extends({}, highlight, { id: getNextId() })].concat(highlights)
    });
  };

  CustomHighlighter.prototype.updateHighlight = function updateHighlight(highlightId, position, content) {
    console.log("Updating highlight", highlightId, position, content);

    this.setState({
      highlights: this.state.highlights.map(function (h) {
        return h.id === highlightId ? _extends({}, h, {
          position: _extends({}, h.position, position),
          content: _extends({}, h.content, content)
        }) : h;
      })
    });
  };

  CustomHighlighter.prototype.render = function render() {
    var _this2 = this;

    var highlights = this.state.highlights;
    var _props = this.props,
        searchObj = _props.searchObj,
        pageNumber = _props.pageNumber,
        className = _props.className,
        pdfUrl = _props.pdfUrl;


    var DEFAULT_URL = pdfUrl;
    var searchParams = new _urlSearchParams2.default(location.search);
    var url = searchParams.get("url") || DEFAULT_URL;

    this.scrollToHighlightFromHash(searchObj);
    return _react2.default.createElement(
      _PdfLoader2.default,
      { url: url, beforeLoad: _react2.default.createElement(_Spinner2.default, null) },
      function (pdfDocument) {
        return _react2.default.createElement(_PdfHighlighter2.default, {
          pdfDocument: pdfDocument,
          enableAreaSelection: function enableAreaSelection(event) {
            return event.altKey;
          },
          onScrollChange: resetHash,
          scrollRef: function scrollRef(scrollTo) {
            _this2.scrollViewerTo = scrollTo;
            _this2.scrollToHighlightFromHash(searchObj);
          },
          highlightTransform: function highlightTransform(searchObj, highlight, index, setTip, hideTip, viewportToScaled, screenshot, isScrolledTo) {
            var isTextHighlight = !Boolean(searchObj.content);

            var component = !_this2.props.sidenav ? _react2.default.createElement(_Highlight2.default, {
              onClick: function onClick() {
                return console.log("Clicked");
              },
              isScrolledTo: isScrolledTo,
              position: searchObj.position,
              comment: searchObj.comment
            }) : null;
            return _react2.default.createElement(_Popup2.default, {
              popupContent: _react2.default.createElement(HighlightPopup, searchObj),
              onMouseOver: function onMouseOver(popupContent) {
                return setTip(highlight, function (highlight) {
                  return popupContent;
                });
              },
              onMouseOut: hideTip,
              key: index,
              children: component
            });
          },
          highlights: searchObj
        });
      }
    );
  };

  return CustomHighlighter;
}(_react.Component);

exports.default = CustomHighlighter;
module.exports = exports['default'];