'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('../style/App.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PdfViewerController = function (_Component) {
    _inherits(PdfViewerController, _Component);

    function PdfViewerController(props) {
        _classCallCheck(this, PdfViewerController);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props));

        _this.setScaleValue = function (val) {
            console.log("scale", val);
            _this.setState({ originalScale: val, scaleValue: val });
        };

        _this.zoomMinus = function () {
            _this.setState({
                scaleValue: _this.state.scaleValue - 0.2
            }, function () {
                return window.PdfViewer.viewer.currentScale = _this.state.scaleValue;
            });
        };

        _this.zoomPlus = function () {
            _this.setState({
                scaleValue: _this.state.scaleValue + 0.2
            }, function () {
                return window.PdfViewer.viewer.currentScale = _this.state.scaleValue;
            });
        };

        _this.zoomReset = function () {
            var _this2 = this;

            this.setState({
                scaleValue: 0.71
            }, function () {
                return window.PdfViewer.viewer.currentScale = _this2.state.originalScale;
            });
        };

        _this.rotateLeft = function () {
            window.PdfViewer.viewer.pagesRotation = 90;
        };

        _this.rotateReset = function () {
            window.PdfViewer.viewer.pagesRotation = 0;
        };

        _this.rotateRight = function () {
            window.PdfViewer.viewer.pagesRotation = -90;
        };

        _this.previousPage = function () {
            var pageNum = window.PdfViewer.viewer.currentPageNumber;
            if (pageNum <= 1) {
                return;
            }
            window.PdfViewer.viewer.currentPageNumber--;
            this.setState({ current: window.PdfViewer.viewer.currentPageNumber, total: window.PdfViewer.viewer.pagesCount });
        };

        _this.nextPage = function () {
            var pageNum = window.PdfViewer.viewer.currentPageNumber;
            var pageCount = window.PdfViewer.viewer.pagesCount;
            if (pageNum >= pageCount) {
                return;
            }
            window.PdfViewer.viewer.currentPageNumber++;
            this.setState({ current: window.PdfViewer.viewer.currentPageNumber, total: window.PdfViewer.viewer.pagesCount });
        };

        _this.state = {
            originalScale: 0.71,
            scaleValue: 0.71,
            current: 0,
            total: 0
        };
        return _this;
    }

    PdfViewerController.prototype.componentDidMount = function componentDidMount() {
        console.log(this.props);
        if (window.PdfViewer) {
            this.setScaleValue(this.props.currentScale);
        }
    };

    PdfViewerController.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
        // if (prevProps.currentScale !== this.props.currentScale) {
        //     this.setState({
        //         scaleValue: this.props.currentScale,
        //     }, () => {
        //         if (window.PdfViewer) {
        //             window.PdfViewer.viewer.currentScale = this.state.scaleValue
        //         }
        //     })
        // }
    };

    PdfViewerController.prototype.render = function render() {
        var _this3 = this;

        var _props = this.props,
            currentPageNum = _props.currentPageNum,
            totalPages = _props.totalPages;

        try {
            var currentPageNumber = window.PdfViewer.viewer.currentPageNumber ? window.PdfViewer.viewer.currentPageNumber : currentPageNum;
            var pagesCount = window.PdfViewer.viewer.pagesCount ? window.PdfViewer.viewer.pagesCount : 1;
        } catch (error) {}
        return _react2.default.createElement(
            'div',
            { className: 'outer-container' },
            _react2.default.createElement(
                'div',
                { className: 'container text-white', style: { backgroundColor: "#343a40bf", borderRadius: '2.25rem' } },
                _react2.default.createElement(
                    'div',
                    { className: 'row py-0 px-2' },
                    _react2.default.createElement(
                        'div',
                        { className: 'col-sm-3 p-0 text-center' },
                        _react2.default.createElement(
                            'div',
                            { className: 'btn-group', role: 'group' },
                            _react2.default.createElement(
                                'button',
                                { type: 'button', className: 'btn btn-sm btn-link text-white pr-2', onClick: function onClick() {
                                        return _this3.zoomMinus();
                                    } },
                                _react2.default.createElement(
                                    'i',
                                    { className: 'material-icons' },
                                    'zoom_out'
                                )
                            ),
                            _react2.default.createElement(
                                'button',
                                { type: 'button', className: 'btn btn-sm btn-link text-white px-2', onClick: function onClick() {
                                        return _this3.zoomReset();
                                    } },
                                _react2.default.createElement(
                                    'i',
                                    { className: 'material-icons' },
                                    'refresh'
                                )
                            ),
                            _react2.default.createElement(
                                'button',
                                { type: 'button', className: 'btn btn-sm btn-link text-white pl-2', onClick: function onClick() {
                                        return _this3.zoomPlus();
                                    } },
                                _react2.default.createElement(
                                    'i',
                                    { className: 'material-icons' },
                                    'zoom_in'
                                )
                            )
                        )
                    ),
                    _react2.default.createElement(
                        'div',
                        { className: 'col-sm-6 p-0 text-center align-items-center' },
                        _react2.default.createElement(
                            'div',
                            { className: 'btn-group', role: 'group' },
                            _react2.default.createElement(
                                'button',
                                { className: 'btn btn-sm btn-link text-white pr-2', onClick: function onClick() {
                                        return _this3.previousPage();
                                    } },
                                _react2.default.createElement(
                                    'i',
                                    { className: 'material-icons' },
                                    'keyboard_arrow_left'
                                )
                            ),
                            _react2.default.createElement(
                                'div',
                                { 'class': 'small d-flex align-items-center' },
                                'Page  ',
                                currentPageNumber,
                                ' / ',
                                pagesCount
                            ),
                            _react2.default.createElement(
                                'button',
                                { className: 'btn btn-sm btn-link text-white pl-2', onClick: function onClick() {
                                        return _this3.nextPage();
                                    } },
                                _react2.default.createElement(
                                    'i',
                                    { className: 'material-icons' },
                                    'keyboard_arrow_right'
                                )
                            )
                        )
                    ),
                    _react2.default.createElement(
                        'div',
                        { className: 'col-sm-3 p-0 text-center' },
                        _react2.default.createElement(
                            'div',
                            { className: 'btn-group', role: 'group' },
                            _react2.default.createElement(
                                'button',
                                { type: 'button', className: 'btn btn-sm btn-link text-white pr-2', onClick: function onClick() {
                                        return _this3.rotateLeft();
                                    } },
                                _react2.default.createElement(
                                    'i',
                                    { className: 'material-icons' },
                                    'rotate_left'
                                )
                            ),
                            _react2.default.createElement(
                                'button',
                                { type: 'button', className: 'btn btn-sm btn-link text-white px-2', onClick: function onClick() {
                                        return _this3.rotateReset();
                                    } },
                                _react2.default.createElement(
                                    'i',
                                    { className: 'material-icons' },
                                    'refresh'
                                )
                            ),
                            _react2.default.createElement(
                                'button',
                                { type: 'button', className: 'btn btn-sm btn-link text-white pl-2', onClick: function onClick() {
                                        return _this3.rotateRight();
                                    } },
                                _react2.default.createElement(
                                    'i',
                                    { className: 'material-icons' },
                                    'rotate_right'
                                )
                            )
                        )
                    )
                )
            )
        );
    };

    return PdfViewerController;
}(_react.Component);

exports.default = PdfViewerController;
module.exports = exports['default'];